#include <stdio.h>
#include <stdlib.h>
#include "dre_app.h"

int main(int argc, char **argv)
{
    dre_return_t result;
    dre_app_handle *h = NULL;
    dre_app_pid_list_t plist;
    char *name = NULL;
    char *exec = argv[0];
    char **p = ++argv;

    int i;
    for(i = 0; p[i]; i++) {
        if(!strcmp(argv[i], "-n") && p[i + 1]) {
            name = argv[++i];
        } else goto arg;
    }
    if(!name) goto arg;

    /* open handler */
    h = dre_app_open(name);
    if(!h) {
        result = DRE_ERR_NULL_POINTER;
        goto error;
    }

    /* get pid list */
    result = dre_app_get_registered_pid_list(h, &plist);
    if(result) goto error;
    if(plist) {
        int j = 0;
        printf("Registered process(es) on '%s':\n", name);
        while(plist[j]) {
            printf("- pid:%d(vpid:%d)\n", (*plist[j]).pid, (*plist[j]).vpid);
            j++;
        }
    } else {
        printf("No process registered on '%s'.\n", name);
    }

    /* release pid list */
    if(plist) {
        result = dre_app_release_registered_pid_list(plist);
        if(result) goto error;
    }

    /* close handler */
    result = dre_app_close(h);
    if(result) goto error;

    return 0;

arg:
    printf("usage: %s -n <name>\n", exec);
    return DRE_ERR_INVALID_ARGUMENT;

error:
    if(h) {
        dre_app_close(h);
    }

    printf("Failed to list pids (ErrNo=%d).\n", result);
    return result;
}

