#include <stdio.h>
#include <stdlib.h>
#include "dre_sys.h"

int main(int argc, char **argv)
{
    dre_return_t result;
    dre_sys_handle *h = NULL;
    int port;
    char *name = NULL;
    char *dest = NULL;
    char *exec = argv[0];
    char **p = ++argv;

    int i;
    for(i = 0; p[i]; i++) {
        if(!strcmp(argv[i], "-n") && p[i + 1]) {
            name = argv[++i];
        } else if(!strcmp(argv[i], "-d") && p[i + 1]) {
            dest = argv[++i];
        } else if(!strcmp(argv[i], "-p") && p[i + 1]) {
            port = atoi(argv[++i]);
        } else goto arg;
    }
    if(!name || !dest || port <= 0) goto arg;

    /* open handler */
    h = dre_sys_open(name);
    if(!h) {
        result = DRE_ERR_NULL_POINTER;
        goto error;
    }

    /* start migration */
    result = dre_sys_migration_start(h, dest, port);
    if(result) goto error;

    /* close handler */
    result = dre_sys_close(h);
    if(result) goto error;

    printf("Started migration of '%s'.\n", name);
    return 0;

arg:
    printf("usage: %s -n <name> -d <dest> -p <port>\n", exec);
    return DRE_ERR_INVALID_ARGUMENT;

error:
    if(h) {
        dre_sys_close(h);
    }

    printf("Failed to start migration of '%s' (ErrNo=%d).\n", name, result);
    return result;
}

