/*
 * (C) Copyright 2009-2013 JST - Japan Science and Technology Agency
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#ifndef _DRE_ERROR_H_
#define _DRE_ERROR_H_

// error type
typedef enum {
    DRE_ERR_INVALID_ARGUMENT         = -101,
    DRE_ERR_PERMISSION_DENIED        = -102,
    DRE_ERR_DAWARE_MOD_NONEXISTENCE  = -103,
    DRE_ERR_NO_VT                    = -104,
    DRE_ERR_CONTAINER_NONEXISTENCE   = -111,
    DRE_ERR_CONTAINER_EXISTENCE      = -112,
    DRE_ERR_CONTAINER_RUNNING        = -113,
    DRE_ERR_CONTAINER_STOPPED        = -114,
    DRE_ERR_CONTAINER_SUSPENDED      = -115,
    DRE_ERR_CONTAINER_BUSY           = -116,
    DRE_ERR_CONTAINER_UNKNOWN_STATUS = -117,
    DRE_ERR_BASE_NONEXISTENCE        = -121,
    DRE_ERR_BASE_EXISTENCE           = -122,
    DRE_ERR_REMOVE_BASE_FAILED       = -123,
    DRE_ERR_SNAPSHOT_NONEXISTENCE    = -131,
    DRE_ERR_SNAPSHOT_EXISTENCE       = -132,
    DRE_ERR_SAVE_SNAPSHOT_FAILED     = -133,
    DRE_ERR_LOAD_SNAPSHOT_FAILED     = -134,
    DRE_ERR_REMOVE_SNAPSHOT_FAILED   = -135,
    DRE_ERR_COMMIT_SNAPSHOT_FAILED   = -136,
    DRE_ERR_CGROUP_NONEXISTENCE      = -141, 
    DRE_ERR_CGROUP_EXISTENCE         = -142, 
    DRE_ERR_PID_NONEXISTENCE         = -143, 
    DRE_ERR_SET_LIMIT_FAILED         = -144, 
    DRE_ERR_UNSET_LIMIT_FAILED       = -145, 
    DRE_ERR_DESTROY_CGROUP_FAILED    = -146, 
    DRE_ERR_DEVICE_BUSY              = -151,
    DRE_ERR_NO_TAP_AVAILABLE         = -152,
    DRE_ERR_NO_SOCKET_AVAILABLE      = -153,
    DRE_ERR_NFS_MOUNT_FAILED         = -154,
    DRE_ERR_BIND_FAILED              = -155,
    DRE_ERR_INVALID_HOSTNAME         = -156,
    DRE_ERR_NULL_POINTER             = -201,
    DRE_ERR_REQUEST_TOO_LONG         = -202
} dre_err_t;

#endif

