#include <stdio.h>
#include <stdlib.h>
#include "dre_app.h"

int main(int argc, char **argv)
{
    dre_return_t result;
    dre_app_handle *h = NULL;
    char *name = NULL;
    char *exec = argv[0];
    char **p = ++argv;

    int i;
    for(i = 0; p[i]; i++) {
        if(!strcmp(argv[i], "-n") && p[i + 1]) {
            name = argv[++i];
        } else goto arg;
    }
    if(!name) goto arg;

    /* open handler */
    h = dre_app_open(name);
    if(!h) {
        result = DRE_ERR_NULL_POINTER;
        goto error;
    }

    /* stop container */
    result = dre_app_stop(h);
    if(result) goto error;

    /* close handler */
    result = dre_app_close(h);
    if(result) goto error;

    printf("Stopped '%s'.\n", name);
    return 0;

arg:
    printf("usage: %s -n <name>\n", exec);
    return DRE_ERR_INVALID_ARGUMENT;

error:
    if(h) {
        dre_app_close(h);
    }

    printf("Failed to stop '%s' (ErrNo=%d).\n", name, result);
    return result;
}

