#include <stdio.h>
#include <stdlib.h>
#include "dre_app.h"

int main(int argc, char **argv)
{
    dre_return_t result;
    dre_app_handle *h = NULL;
    char *name = NULL;
    char *cgroup = NULL;
    char *exec = argv[0];
    int pid = 0;
    char **p = ++argv;

    int i;
    for(i = 0; p[i]; i++) {
        if(!strcmp(argv[i], "-n") && p[i + 1]) {
            name = argv[++i];
        } else if(!strcmp(argv[i], "-g") && p[i + 1]) {
            cgroup = argv[++i];
        } else if(!strcmp(argv[i], "--pid") && p[i + 1]) {
            pid = atoi(argv[++i]);
        } else goto arg;
    }
    if(!cgroup || pid <= 0) goto arg;

    /* open handler */
    if(name) {
        h = dre_app_open(name);
        if(!h) {
            result = DRE_ERR_NULL_POINTER;
            goto error;
        }
    }

    /* register pid */
    result = dre_app_register_pid(h, pid);
    if(result) goto error;

    /* unbind from control group */
    result = dre_app_unbind_pid(h, cgroup, pid);
    if(result) goto error;

    /* unregister pid */
    result = dre_app_unregister_pid(h, pid);
    if(result) goto error;

    /* close handler */
    if(h) {
        result = dre_app_close(h);
        if(result) goto error;
    }

    printf("Unbound %d from '%s'.\n", pid, cgroup);
    return 0;

arg:
    printf("usage: %s -g <cgroup> --pid <pid> [-n <name>]\n", exec);
    return DRE_ERR_INVALID_ARGUMENT;

error:
    if(h) {
        dre_app_close(h);
    }

    printf("Failed to unbind %d from '%s' (ErrNo=%d).\n", pid, cgroup, result);
    return result;
}

