#include <stdio.h>
#include <stdlib.h>
#include "dre_sys.h"

int main(int argc, char **argv)
{
    dre_return_t result;
    dre_sys_handle *h = NULL;
    dre_list_t list;
    char *name = NULL;
    char *exec = argv[0];
    char **p = ++argv;

    int i;
    for(i = 0; p[i]; i++) {
        if(!strcmp(argv[i], "-n") && p[i + 1]) {
            name = argv[++i];
        } else goto arg;
    }
    if(!name) goto arg;

    /* open handler */
    h = dre_sys_open(name);
    if(!h) {
        result = DRE_ERR_NULL_POINTER;
        goto error;
    }

    /* get snapshot list */
    result = dre_sys_get_snapshot_list(h, &list);
    if(result) goto error;
    if(list) {
        int j = 0;
        while(*(list + j)) {
            printf("%s\n", *(list + j));
            j++;
        }
    }

    /* release snapshot list */
    if(list) {
        result = dre_sys_release_snapshot_list(list);
        if(result) goto error;
    }

    /* close handler */
    result = dre_sys_close(h);
    if(result) goto error;

    return 0;

arg:
    printf("usage: %s -n <name>\n", exec);
    return DRE_ERR_INVALID_ARGUMENT;

error:
    printf("Failed to list containers (ErrNo=%d).\n", result);
    return result;
}

