#/bin/sh

NAME="daware-mod"
VERSION="1.0"

dkms_status()
{
    echo `dkms status -m ${NAME} -v ${VERSION} | sed 's/^.*: \(.*\)$/\1/'`
}

if [ $(id -u) != '0' ]
then
    echo "Permission denied."
    exit
fi

if [ "`dkms_status`" = 'installed' ]
then
    echo "${NAME}-${VERSION} already installed."
fi

if [ -z "`dkms_status`" ]
then
    dkms add -m ${NAME} -v ${VERSION}
fi

if [ "`dkms_status`" = 'added' ]
then
    headers="linux-headers-`uname -r`"
    if [ -z "`dpkg -l | grep ${headers}`" ]
    then
        apt-get install -y ${headers}
    fi
fi

if [ "`dkms_status`" = 'added' ]
then
    dkms build -m ${NAME} -v ${VERSION}
fi

if [ "`dkms_status`" = 'built' ]
then
    dkms install -m ${NAME} -v ${VERSION}
fi

mod_dir="/lib/modules/`uname -r`"

if [ -z "`grep 'updates/dkms/daware.ko' ${mod_dir}/modules.dep`" ]
then
    depmod -a
fi

if [ -z "`lsmod | grep daware`" ]
then
    modprobe daware
fi

